<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="UTF-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Document</title>
</head>
<body>;
<blockquote>
<p>Note:</p>
<p>The legacy context API will be removed in a future major version. Use the <a href="/docs/context.html">new context API</a> introduced with version 16.3. The legacy API will continue working for all 16.x releases.</p>
</blockquote>
<h2 id="how-to-use-context">How To Use Context</h2>
<blockquote>
<p>This section documents a legacy API. See the <a href="/docs/context.html">new API</a>.</p>
</blockquote>
<p>Suppose you have a structure like:</p>
<div class="sourceCode" id="cb1"><pre class="sourceCode javascript"><code class="sourceCode javascript"><a class="sourceLine" id="cb1-1" title="1"><span class="kw">class</span> Button <span class="kw">extends</span> <span class="va">React</span>.<span class="at">Component</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb1-2" title="2">  <span class="at">render</span>() <span class="op">{</span></a>
<a class="sourceLine" id="cb1-3" title="3">    <span class="cf">return</span> (</a>
<a class="sourceLine" id="cb1-4" title="4">      <span class="op">&lt;</span>button style<span class="op">={{</span><span class="dt">background</span><span class="op">:</span> <span class="kw">this</span>.<span class="va">props</span>.<span class="at">color</span><span class="op">}}&gt;</span></a>
<a class="sourceLine" id="cb1-5" title="5">        <span class="op">{</span><span class="kw">this</span>.<span class="va">props</span>.<span class="at">children</span><span class="op">}</span></a>
<a class="sourceLine" id="cb1-6" title="6">      &lt;/button<span class="op">&gt;</span></a>
<a class="sourceLine" id="cb1-7" title="7">    )<span class="op">;</span></a>
<a class="sourceLine" id="cb1-8" title="8">  <span class="op">}</span></a>
<a class="sourceLine" id="cb1-9" title="9"><span class="op">}</span></a>
<a class="sourceLine" id="cb1-10" title="10"></a>
<a class="sourceLine" id="cb1-11" title="11"><span class="kw">class</span> Message <span class="kw">extends</span> <span class="va">React</span>.<span class="at">Component</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb1-12" title="12">  <span class="at">render</span>() <span class="op">{</span></a>
<a class="sourceLine" id="cb1-13" title="13">    <span class="cf">return</span> (</a>
<a class="sourceLine" id="cb1-14" title="14">      <span class="op">&lt;</span>div<span class="op">&gt;</span></a>
<a class="sourceLine" id="cb1-15" title="15">        <span class="op">{</span><span class="kw">this</span>.<span class="va">props</span>.<span class="at">text</span><span class="op">}</span> <span class="op">&lt;</span>Button color<span class="op">={</span><span class="kw">this</span>.<span class="va">props</span>.<span class="at">color</span><span class="op">}&gt;</span>Delete&lt;/Button<span class="op">&gt;</span></a>
<a class="sourceLine" id="cb1-16" title="16">      &lt;/div<span class="op">&gt;</span></a>
<a class="sourceLine" id="cb1-17" title="17">    )<span class="op">;</span></a>
<a class="sourceLine" id="cb1-18" title="18">  <span class="op">}</span></a>
<a class="sourceLine" id="cb1-19" title="19"><span class="op">}</span></a>
<a class="sourceLine" id="cb1-20" title="20"></a>
<a class="sourceLine" id="cb1-21" title="21"><span class="kw">class</span> MessageList <span class="kw">extends</span> <span class="va">React</span>.<span class="at">Component</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb1-22" title="22">  <span class="at">render</span>() <span class="op">{</span></a>
<a class="sourceLine" id="cb1-23" title="23">    <span class="kw">const</span> color <span class="op">=</span> <span class="st">&quot;purple&quot;</span><span class="op">;</span></a>
<a class="sourceLine" id="cb1-24" title="24">    <span class="kw">const</span> children <span class="op">=</span> <span class="kw">this</span>.<span class="va">props</span>.<span class="va">messages</span>.<span class="at">map</span>((message) <span class="kw">=&gt;</span></a>
<a class="sourceLine" id="cb1-25" title="25">      <span class="op">&lt;</span>Message text<span class="op">={</span><span class="va">message</span>.<span class="at">text</span><span class="op">}</span> color<span class="op">={</span>color<span class="op">}</span> /&gt;</a>
<a class="sourceLine" id="cb1-26" title="26">    )<span class="op">;</span></a>
<a class="sourceLine" id="cb1-27" title="27">    <span class="cf">return</span> <span class="op">&lt;</span>div<span class="op">&gt;{</span>children<span class="op">}</span>&lt;/div<span class="op">&gt;;</span></a>
<a class="sourceLine" id="cb1-28" title="28">  <span class="op">}</span></a>
<a class="sourceLine" id="cb1-29" title="29"><span class="op">}</span></a></code></pre></div>
<p>In this example, we manually thread through a <code>color</code> prop in order to style the <code>Button</code> and <code>Message</code> components appropriately. Using context, we can pass this through the tree automatically:</p>
<pre class="javascript{6,13-15,21,28-30,40-42}"><code>import PropTypes from &#39;prop-types&#39;;

class Button extends React.Component {
  render() {
    return (
      &lt;button style={{background: this.context.color}}&gt;
        {this.props.children}
      &lt;/button&gt;
    );
  }
}

Button.contextTypes = {
  color: PropTypes.string
};

class Message extends React.Component {
  render() {
    return (
      &lt;div&gt;
        {this.props.text} &lt;Button&gt;Delete&lt;/Button&gt;
      &lt;/div&gt;
    );
  }
}

class MessageList extends React.Component {
  getChildContext() {
    return {color: &quot;purple&quot;};
  }

  render() {
    const children = this.props.messages.map((message) =&gt;
      &lt;Message text={message.text} /&gt;
    );
    return &lt;div&gt;{children}&lt;/div&gt;;
  }
}

MessageList.childContextTypes = {
  color: PropTypes.string
};</code></pre>
<p>By adding <code>childContextTypes</code> and <code>getChildContext</code> to <code>MessageList</code> (the context provider), React passes the information down automatically and any component in the subtree (in this case, <code>Button</code>) can access it by defining <code>contextTypes</code>.</p>
<p>If <code>contextTypes</code> is not defined, then <code>context</code> will be an empty object.</p>
<blockquote>
<p>Note:</p>
<p><code>React.PropTypes</code> has moved into a different package since React v15.5. Please use <a href="https://www.npmjs.com/package/prop-types">the <code>prop-types</code> library instead</a> to define <code>contextTypes</code>.</p>
<p>We provide <a href="/blog/2017/04/07/react-v15.5.0.html#migrating-from-react.proptypes">a codemod script</a> to automate the conversion.</p>
</blockquote>
<h3 id="parent-child-coupling">Parent-Child Coupling</h3>
<blockquote>
<p>This section documents a legacy API. See the <a href="/docs/context.html">new API</a>.</p>
</blockquote>
<p>Context can also let you build an API where parents and children communicate. For example, one library that works this way is <a href="https://reacttraining.com/react-router">React Router V4</a>:</p>
<div class="sourceCode" id="cb3"><pre class="sourceCode javascript"><code class="sourceCode javascript"><a class="sourceLine" id="cb3-1" title="1"><span class="im">import</span> <span class="op">{</span> BrowserRouter <span class="im">as</span> Router<span class="op">,</span> Route<span class="op">,</span> Link <span class="op">}</span> <span class="im">from</span> <span class="st">&#39;react-router-dom&#39;</span><span class="op">;</span></a>
<a class="sourceLine" id="cb3-2" title="2"></a>
<a class="sourceLine" id="cb3-3" title="3"><span class="kw">const</span> BasicExample <span class="op">=</span> () <span class="kw">=&gt;</span> (</a>
<a class="sourceLine" id="cb3-4" title="4">  <span class="op">&lt;</span>Router<span class="op">&gt;</span></a>
<a class="sourceLine" id="cb3-5" title="5">    <span class="op">&lt;</span>div<span class="op">&gt;</span></a>
<a class="sourceLine" id="cb3-6" title="6">      <span class="op">&lt;</span>ul<span class="op">&gt;</span></a>
<a class="sourceLine" id="cb3-7" title="7">        <span class="op">&lt;</span>li<span class="op">&gt;&lt;</span>Link to<span class="op">=</span><span class="st">&quot;/&quot;</span><span class="op">&gt;</span>Home&lt;/Link<span class="op">&gt;</span>&lt;/li<span class="op">&gt;</span></a>
<a class="sourceLine" id="cb3-8" title="8">        <span class="op">&lt;</span>li<span class="op">&gt;&lt;</span>Link to<span class="op">=</span><span class="st">&quot;/about&quot;</span><span class="op">&gt;</span>About&lt;/Link<span class="op">&gt;</span>&lt;/li<span class="op">&gt;</span></a>
<a class="sourceLine" id="cb3-9" title="9">        <span class="op">&lt;</span>li<span class="op">&gt;&lt;</span>Link to<span class="op">=</span><span class="st">&quot;/topics&quot;</span><span class="op">&gt;</span>Topics&lt;/Link<span class="op">&gt;</span>&lt;/li<span class="op">&gt;</span></a>
<a class="sourceLine" id="cb3-10" title="10">      &lt;/ul<span class="op">&gt;</span></a>
<a class="sourceLine" id="cb3-11" title="11"></a>
<a class="sourceLine" id="cb3-12" title="12">      <span class="op">&lt;</span>hr /<span class="op">&gt;</span></a>
<a class="sourceLine" id="cb3-13" title="13"></a>
<a class="sourceLine" id="cb3-14" title="14">      <span class="op">&lt;</span>Route exact path<span class="op">=</span><span class="st">&quot;/&quot;</span> component<span class="op">={</span>Home<span class="op">}</span> /&gt;</a>
<a class="sourceLine" id="cb3-15" title="15">      <span class="op">&lt;</span>Route path<span class="op">=</span><span class="st">&quot;/about&quot;</span> component<span class="op">={</span>About<span class="op">}</span> /&gt;</a>
<a class="sourceLine" id="cb3-16" title="16">      <span class="op">&lt;</span>Route path<span class="op">=</span><span class="st">&quot;/topics&quot;</span> component<span class="op">={</span>Topics<span class="op">}</span> /&gt;</a>
<a class="sourceLine" id="cb3-17" title="17">    &lt;/div<span class="op">&gt;</span></a>
<a class="sourceLine" id="cb3-18" title="18">  &lt;/Router<span class="op">&gt;</span></a>
<a class="sourceLine" id="cb3-19" title="19">)<span class="op">;</span></a></code></pre></div>
<p>By passing down some information from the <code>Router</code> component, each <code>Link</code> and <code>Route</code> can communicate back to the containing <code>Router</code>.</p>
<p>Before you build components with an API similar to this, consider if there are cleaner alternatives. For example, you can pass entire React components as props if you’d like to.</p>
<h3 id="referencing-context-in-lifecycle-methods">Referencing Context in Lifecycle Methods</h3>
<blockquote>
<p>This section documents a legacy API. See the <a href="/docs/context.html">new API</a>.</p>
</blockquote>
<p>If <code>contextTypes</code> is defined within a component, the following <a href="/docs/react-component.html#the-component-lifecycle">lifecycle methods</a> will receive an additional parameter, the <code>context</code> object:</p>
<ul>
<li><a href="/docs/react-component.html#constructor"><code>constructor(props, context)</code></a></li>
<li><a href="/docs/react-component.html#componentwillreceiveprops"><code>componentWillReceiveProps(nextProps, nextContext)</code></a></li>
<li><a href="/docs/react-component.html#shouldcomponentupdate"><code>shouldComponentUpdate(nextProps, nextState, nextContext)</code></a></li>
<li><a href="/docs/react-component.html#componentwillupdate"><code>componentWillUpdate(nextProps, nextState, nextContext)</code></a></li>
</ul>
<blockquote>
<p>Note:</p>
<p>As of React 16, <code>componentDidUpdate</code> no longer receives <code>prevContext</code>.</p>
</blockquote>
<h3 id="referencing-context-in-stateless-function-components">Referencing Context in Function Components</h3>
<blockquote>
<p>This section documents a legacy API. See the <a href="/docs/context.html">new API</a>.</p>
</blockquote>
<p>Function components are also able to reference <code>context</code> if <code>contextTypes</code> is defined as a property of the function. The following code shows a <code>Button</code> component written as a function component.</p>
<div class="sourceCode" id="cb4"><pre class="sourceCode javascript"><code class="sourceCode javascript"><a class="sourceLine" id="cb4-1" title="1"><span class="im">import</span> PropTypes <span class="im">from</span> <span class="st">&#39;prop-types&#39;</span><span class="op">;</span></a>
<a class="sourceLine" id="cb4-2" title="2"></a>
<a class="sourceLine" id="cb4-3" title="3"><span class="kw">const</span> Button <span class="op">=</span> (<span class="op">{</span>children<span class="op">},</span> context) <span class="kw">=&gt;</span></a>
<a class="sourceLine" id="cb4-4" title="4">  <span class="op">&lt;</span>button style<span class="op">={{</span><span class="dt">background</span><span class="op">:</span> <span class="va">context</span>.<span class="at">color</span><span class="op">}}&gt;</span></a>
<a class="sourceLine" id="cb4-5" title="5">    <span class="op">{</span>children<span class="op">}</span></a>
<a class="sourceLine" id="cb4-6" title="6">  &lt;/button<span class="op">&gt;;</span></a>
<a class="sourceLine" id="cb4-7" title="7"></a>
<a class="sourceLine" id="cb4-8" title="8"><span class="va">Button</span>.<span class="at">contextTypes</span> <span class="op">=</span> <span class="op">{</span><span class="dt">color</span><span class="op">:</span> <span class="va">PropTypes</span>.<span class="at">string</span><span class="op">};</span></a></code></pre></div>
<h3 id="updating-context">Updating Context</h3>
<blockquote>
<p>This section documents a legacy API. See the <a href="/docs/context.html">new API</a>.</p>
</blockquote>
<p>Don’t do it.</p>
<p>React has an API to update context, but it is fundamentally broken and you should not use it.</p>
<p>The <code>getChildContext</code> function will be called when the state or props changes. In order to update data in the context, trigger a local state update with <code>this.setState</code>. This will trigger a new context and changes will be received by the children.</p>
<div class="sourceCode" id="cb5"><pre class="sourceCode javascript"><code class="sourceCode javascript"><a class="sourceLine" id="cb5-1" title="1"><span class="im">import</span> PropTypes <span class="im">from</span> <span class="st">&#39;prop-types&#39;</span><span class="op">;</span></a>
<a class="sourceLine" id="cb5-2" title="2"></a>
<a class="sourceLine" id="cb5-3" title="3"><span class="kw">class</span> MediaQuery <span class="kw">extends</span> <span class="va">React</span>.<span class="at">Component</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb5-4" title="4">  <span class="at">constructor</span>(props) <span class="op">{</span></a>
<a class="sourceLine" id="cb5-5" title="5">    <span class="kw">super</span>(props)<span class="op">;</span></a>
<a class="sourceLine" id="cb5-6" title="6">    <span class="kw">this</span>.<span class="at">state</span> <span class="op">=</span> <span class="op">{</span><span class="dt">type</span><span class="op">:</span><span class="st">&#39;desktop&#39;</span><span class="op">};</span></a>
<a class="sourceLine" id="cb5-7" title="7">  <span class="op">}</span></a>
<a class="sourceLine" id="cb5-8" title="8"></a>
<a class="sourceLine" id="cb5-9" title="9">  <span class="at">getChildContext</span>() <span class="op">{</span></a>
<a class="sourceLine" id="cb5-10" title="10">    <span class="cf">return</span> <span class="op">{</span><span class="dt">type</span><span class="op">:</span> <span class="kw">this</span>.<span class="va">state</span>.<span class="at">type</span><span class="op">};</span></a>
<a class="sourceLine" id="cb5-11" title="11">  <span class="op">}</span></a>
<a class="sourceLine" id="cb5-12" title="12"></a>
<a class="sourceLine" id="cb5-13" title="13">  <span class="at">componentDidMount</span>() <span class="op">{</span></a>
<a class="sourceLine" id="cb5-14" title="14">    <span class="kw">const</span> checkMediaQuery <span class="op">=</span> () <span class="kw">=&gt;</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb5-15" title="15">      <span class="kw">const</span> type <span class="op">=</span> <span class="va">window</span>.<span class="at">matchMedia</span>(<span class="st">&quot;(min-width: 1025px)&quot;</span>).<span class="at">matches</span> <span class="op">?</span> <span class="st">&#39;desktop&#39;</span> : <span class="st">&#39;mobile&#39;</span><span class="op">;</span></a>
<a class="sourceLine" id="cb5-16" title="16">      <span class="cf">if</span> (type <span class="op">!==</span> <span class="kw">this</span>.<span class="va">state</span>.<span class="at">type</span>) <span class="op">{</span></a>
<a class="sourceLine" id="cb5-17" title="17">        <span class="kw">this</span>.<span class="at">setState</span>(<span class="op">{</span>type<span class="op">}</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb5-18" title="18">      <span class="op">}</span></a>
<a class="sourceLine" id="cb5-19" title="19">    <span class="op">};</span></a>
<a class="sourceLine" id="cb5-20" title="20"></a>
<a class="sourceLine" id="cb5-21" title="21">    <span class="va">window</span>.<span class="at">addEventListener</span>(<span class="st">&#39;resize&#39;</span><span class="op">,</span> checkMediaQuery)<span class="op">;</span></a>
<a class="sourceLine" id="cb5-22" title="22">    <span class="at">checkMediaQuery</span>()<span class="op">;</span></a>
<a class="sourceLine" id="cb5-23" title="23">  <span class="op">}</span></a>
<a class="sourceLine" id="cb5-24" title="24"></a>
<a class="sourceLine" id="cb5-25" title="25">  <span class="at">render</span>() <span class="op">{</span></a>
<a class="sourceLine" id="cb5-26" title="26">    <span class="cf">return</span> <span class="kw">this</span>.<span class="va">props</span>.<span class="at">children</span><span class="op">;</span></a>
<a class="sourceLine" id="cb5-27" title="27">  <span class="op">}</span></a>
<a class="sourceLine" id="cb5-28" title="28"><span class="op">}</span></a>
<a class="sourceLine" id="cb5-29" title="29"></a>
<a class="sourceLine" id="cb5-30" title="30"><span class="va">MediaQuery</span>.<span class="at">childContextTypes</span> <span class="op">=</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb5-31" title="31">  <span class="dt">type</span><span class="op">:</span> <span class="va">PropTypes</span>.<span class="at">string</span></a>
<a class="sourceLine" id="cb5-32" title="32"><span class="op">};</span></a></code></pre></div>
<p>The problem is, if a context value provided by component changes, descendants that use that value won’t update if an intermediate parent returns <code>false</code> from <code>shouldComponentUpdate</code>. This is totally out of control of the components using context, so there’s basically no way to reliably update the context. <a href="https://medium.com/@mweststrate/how-to-safely-use-react-context-b7e343eff076">This blog post</a> has a good explanation of why this is a problem and how you might get around it.</p>
</body></html>
